
<?php

session_start();
header('Content-Type:text/html;charset=utf-8');
    
require_once ('../mTokenOTPServer.php');

$servername = "localhost";
$dbname = "motp_db";

$conn = mysqli_connect($servername, "root", "root");
if (!$conn) 
{
    die("连接数据库失败: " . mysqli_connect_error());
}

if (!mysqli_query($conn,"create database if not exists `$dbname`;"))
{
    die ('1:'.mysqli_error($conn));
}

$conn = mysqli_connect($servername, "root", "root", $dbname);
if (!$conn) 
{
    die("连接数据库失败: " . mysqli_connect_error());
}


$sql = "CREATE TABLE if not exists `users` (`Id` int(11) unsigned NOT NULL AUTO_INCREMENT, `uUserNum` varchar(255) NOT NULL DEFAULT '', `uSeed` longtext NOT NULL,`uWnd` int(11) unsigned NOT NULL DEFAULT '10',`uYear` int(11) unsigned DEFAULT '1970',PRIMARY KEY (`Id`)) ENGINE=MyISAM AUTO_INCREMENT=11 DEFAULT CHARSET=utf8;";
if (! mysqli_query($conn, $sql)) 
{
    die ('2:'.mysqli_error($conn));
}

$utcyear = $_POST["year"];
$nAuthWindow = $_POST["nwind"];
$userSN= $_POST["userNum"];
$seckey = $_POST["seckey"];
$salg = $_POST["salg"];//种子码加密方式  MOTP_SBASE32\MOTP_SHEX  0\1
$otype = $_POST["otype"];//otp 类型  MOTP_TOTP\MOTP_HOTP  0\1
$halg = $_POST["halg"];//算法类型 MOTP_HSHA1\MOTP_HSHA224\MOTP_HSHA256\MOTP_HSHA384\MOTP_HSHA512\MOTP_HMD5\MOTP_HSM3  0\1\2\3\4\5\6
$intervalC = $_POST["intervalCC"]; //hotp C //totp eg:30s 60s 

if(!empty($intervalC) )
{
    if($intervalC=="0" && $otype=="0")
        $intervalC='60';//时间型，设置默认步长
    $seckey = $otype.' '.$halg.' '.$salg.' '.$intervalC.' '.$seckey;
}


echo '<br /><br />';
echo '登录注册详细信息';
echo '<br /><br />';
echo '用户序列号：';
echo $userSN;
echo '<br /><br />';
echo 'OTP类型：';
echo ($otype=="0" ) ? "时间型":"事件型";
echo '<br /><br />';
echo '用户种子码：';
echo ($salg=="0" ) ? "base32":"hex";
echo '<br /><br />';
echo $seckey;
echo '<br /><br />';
echo '算法类型：';
    if($halg == "0")
        echo "hmac-sha1";
    else if($halg == "1")
        echo "hmac-sha224";
    else if($halg == "2")
        echo "hmac-sha256";
    else if($halg == "3")
        echo "hmac-sha384";
    else if($halg == "4")
        echo "hmac-sha512";
    else if($halg == "5")
        echo "hmac-md5";
    else if($halg == "6")
        echo "hmac-sm3";
    else
        echo "未知的算法类型";
echo '<br /><br />';
echo '基准年：'.$utcyear;
echo '<br /><br />';
echo '认证窗口期：'.$nAuthWindow;
echo '<br /><br />';
echo '<br /><br />';

$utcyear=intval($utcyear);
$nAuthWindow=intval($nAuthWindow);

$dog = mTokenOTPServer::getInstance();

$nVer = 2;
$EnvRes = "";

$userNum = strval($userSN);
//var_dump($userNum);

$nRet = $dog->SeedEnv($nVer, $userNum, $seckey, $EnvRes);
if($nRet == 0)
{
    if(empty($EnvRes))
    {
        echo "生成用户种子码失败";
        die;
    }

    echo "用户种子码为 ".$EnvRes;

    $query = "select * from users where uUserNum = '$userNum'";
    $result = mysqli_query($conn, $query);
	if (mysqli_num_rows($result) > 0) 
	{       
		//默认用户名唯一，所以取第一条数据， while($row = mysqli_fetch_assoc($result)) 
        $query   = "update users set uSeed = '$EnvRes' ,uWnd=$nAuthWindow, uYear=$utcyear  where  uUserNum= '$userNum'";  
        $result = mysqli_query($conn, $query);
        if($result)  
        {
            echo '注册成功';
            echo   "更新数据成功,5秒钟后跳转注册页面!";  
            Header('Refresh: 5;url=index.php');
        }            
        else
            echo   "更新数据失败";

    }
    else
    {
        $query   = "INSERT INTO `users` (uUserNum, uSeed, uWnd, uYear) VALUES ('$userNum','$EnvRes',$nAuthWindow,$utcyear)";        
        $result = mysqli_query($conn, $query);
        if($result)  
        {
            echo '注册成功';
            echo '<br /><br />';
            echo   "插入数据成功,5秒钟后跳转注册页面!";  
            Header('Refresh: 5;url=index.php');
        }           
        else
        {
            echo '<br /><br />';
            echo   "插入数据失败";
        }
            
    }
}
else if($nRet == 15728641)
{
    echo "无效的种子码，可能是种子码类型编码有误";
}
else
{
    echo '注册失败';
}

mysqli_close($conn);
?>